Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 4501)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 4502)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Implementation of ice microphysics
+! 
+! 4495 2020-04-13 20:11:20Z raasch
 ! restart data handling with MPI-IO added
 ! 
@@ -148,6 +151,6 @@
 
 !
-!-- Data type used to identify grid-points where horizontal boundary conditions 
-!-- are applied 
+!-- Data type used to identify grid-points where horizontal boundary conditions
+!-- are applied
     TYPE bc_type
        INTEGER(iwp) :: ioff !< offset value in x-direction, used to determine index of surface element
@@ -156,18 +159,18 @@
        INTEGER(iwp) :: ns   !< number of surface elements on the PE
 
-       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  i !< x-index linking to the PALM 3D-grid  
-       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  j !< y-index linking to the PALM 3D-grid    
-       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  k !< z-index linking to the PALM 3D-grid   
-
-       INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE :: start_index !< start index within surface data type for given (j,i) 
-       INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE :: end_index   !< end index within surface data type for given (j,i)  
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  i !< x-index linking to the PALM 3D-grid
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  j !< y-index linking to the PALM 3D-grid
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  k !< z-index linking to the PALM 3D-grid
+
+       INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE :: start_index !< start index within surface data type for given (j,i)
+       INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE :: end_index   !< end index within surface data type for given (j,i)
 
     END TYPE bc_type
 !
-!-- Data type used to identify and treat surface-bounded grid points  
+!-- Data type used to identify and treat surface-bounded grid points
     TYPE surf_type
 
        LOGICAL ::  albedo_from_ascii = .FALSE. !< flag indicating that albedo for urban surfaces is input via ASCII format (just for a workaround)
-    
+
        INTEGER(iwp) :: ioff                                !< offset value in x-direction, used to determine index of surface element
        INTEGER(iwp) :: joff                                !< offset value in y-direction, used to determine index of surface element
@@ -175,14 +178,14 @@
        INTEGER(iwp) :: ns                                  !< number of surface elements on the PE
 
-       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  i       !< x-index linking to the PALM 3D-grid  
-       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  j       !< y-index linking to the PALM 3D-grid    
-       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  k       !< z-index linking to the PALM 3D-grid       
-
-       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  facing  !< Bit indicating surface orientation 
-     
-       INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE :: start_index !< Start index within surface data type for given (j,i) 
-       INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE :: end_index   !< End index within surface data type for given (j,i)  
-
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  z_mo      !< surface-layer height 
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  i       !< x-index linking to the PALM 3D-grid
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  j       !< y-index linking to the PALM 3D-grid
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  k       !< z-index linking to the PALM 3D-grid
+
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  facing  !< Bit indicating surface orientation
+
+       INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE :: start_index !< Start index within surface data type for given (j,i)
+       INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE :: end_index   !< End index within surface data type for given (j,i)
+
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  z_mo      !< surface-layer height
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  uvw_abs   !< absolute surface-parallel velocity
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  us        !< friction velocity
@@ -192,4 +195,6 @@
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  qcs       !< scaling parameter qc
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  ncs       !< scaling parameter nc
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  qis       !< scaling parameter qi
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  nis       !< scaling parameter ni
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  qrs       !< scaling parameter qr
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  nrs       !< scaling parameter nr
@@ -205,16 +210,18 @@
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  qv1       !< mixing ratio at first grid level
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  vpt1      !< virtual potential temperature at first grid level
-       
+
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  css     !< scaling parameter chemical species
 !
 !--    Define arrays for surface fluxes
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  usws      !< vertical momentum flux for u-component at horizontal surfaces
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  vsws      !< vertical momentum flux for v-component at horizontal surfaces 
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  vsws      !< vertical momentum flux for v-component at horizontal surfaces
 
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  shf       !< surface flux sensible heat
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  qsws      !< surface flux latent heat 
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  qsws      !< surface flux latent heat
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  ssws      !< surface flux passive scalar
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  qcsws     !< surface flux qc
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  ncsws     !< surface flux nc
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  qisws     !< surface flux qi
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  nisws     !< surface flux ni
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  qrsws     !< surface flux qr
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  nrsws     !< surface flux nr
@@ -224,5 +231,5 @@
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  amsws   !< surface flux aerosol mass:   dim 1: flux, dim 2: bin
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  gtsws   !< surface flux gesous tracers: dim 1: flux, dim 2: gas
-       
+
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  cssws   !< surface flux chemical species
 !
@@ -240,5 +247,5 @@
        CHARACTER(LEN=40), DIMENSION(:), ALLOCATABLE ::  vegetation_type_name  !< water type at name surface element
        CHARACTER(LEN=40), DIMENSION(:), ALLOCATABLE ::  water_type_name       !< water type at name surface element
-       
+
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nzt_pavement     !< top index for pavement in soil
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  building_type    !< building type at surface element
@@ -246,5 +253,5 @@
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  vegetation_type  !< vegetation type at surface element
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  water_type       !< water type at surface element
-       
+
        INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  albedo_type   !< albedo type, for each fraction (wall,green,window or vegetation,pavement water)
 
@@ -254,5 +261,5 @@
        LOGICAL, DIMENSION(:), ALLOCATABLE  ::  water_surface       !< flag parameter for water surfaces
        LOGICAL, DIMENSION(:), ALLOCATABLE  ::  vegetation_surface  !< flag parameter for natural land surfaces
-       
+
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  albedo            !< broadband albedo for each surface fraction (LSM: vegetation, water, pavement; USM: wall, green, window)
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  emissivity        !< emissivity of the surface, for each fraction  (LSM: vegetation, water, pavement; USM: wall, green, window)
@@ -271,10 +278,10 @@
        REAL(wp), DIMENSION(:), ALLOCATABLE   ::  pt_surface        !< skin-surface temperature
        REAL(wp), DIMENSION(:), ALLOCATABLE   ::  vpt_surface       !< skin-surface virtual temperature
-       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  rad_net           !< net radiation 
+       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  rad_net           !< net radiation
        REAL(wp), DIMENSION(:), ALLOCATABLE   ::  rad_net_l         !< net radiation, used in USM
-       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lambda_h          !< heat conductivity of soil/ wall (W/m/K) 
-       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lambda_h_green    !< heat conductivity of green soil (W/m/K) 
-       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lambda_h_window   !< heat conductivity of windows (W/m/K) 
-       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lambda_h_def      !< default heat conductivity of soil (W/m/K)   
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lambda_h          !< heat conductivity of soil/ wall (W/m/K)
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lambda_h_green    !< heat conductivity of green soil (W/m/K)
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lambda_h_window   !< heat conductivity of windows (W/m/K)
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lambda_h_def      !< default heat conductivity of soil (W/m/K)
 
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  rad_lw_in           !< incoming longwave radiation
@@ -302,5 +309,5 @@
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  qsws_veg            !< surface flux of latent heat (vegetation portion)
 
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  r_a                 !< aerodynamic resistance 
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  r_a                 !< aerodynamic resistance
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  r_a_green           !< aerodynamic resistance at green fraction
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  r_a_window          !< aerodynamic resistance at window fraction
@@ -310,7 +317,7 @@
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  r_s                 !< total surface resistance (combination of r_soil and r_canopy)
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  r_canopy_min        !< minimum canopy (stomatal) resistance
-       
+
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  pt_10cm             !< near surface air potential temperature at distance 10 cm from the surface (K)
-       
+
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  alpha_vg          !< coef. of Van Genuchten
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lambda_w          !< hydraulic diffusivity of soil (?)
@@ -322,11 +329,11 @@
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  m_sat             !< saturation soil moisture (m3/m3)
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  m_wilt            !< soil moisture at permanent wilting point (m3/m3)
-       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  n_vg              !< coef. Van Genuchten  
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  n_vg              !< coef. Van Genuchten
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  rho_c_total_def   !< default volumetric heat capacity of the (soil) layer (J/m3/K)
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  rho_c_total       !< volumetric heat capacity of the actual soil matrix (J/m3/K)
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  root_fr           !< root fraction within the soil layers
-       
+
 !--    Indoor model variables
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  waste_heat          !< waste heat 
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  waste_heat          !< waste heat
 !
 !--    Urban surface variables
@@ -334,8 +341,8 @@
 
        LOGICAL, DIMENSION(:), ALLOCATABLE  ::  isroof_surf          !< flag indicating roof surfaces
-       LOGICAL, DIMENSION(:), ALLOCATABLE  ::  ground_level         !< flag indicating ground floor level surfaces 
+       LOGICAL, DIMENSION(:), ALLOCATABLE  ::  ground_level         !< flag indicating ground floor level surfaces
 
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  target_temp_summer  !< indoor target temperature summer
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  target_temp_winter  !< indoor target temperature summer        
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  target_temp_winter  !< indoor target temperature summer
 
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_surface           !< heat capacity of the wall surface skin (J/m2/K)
@@ -373,5 +380,5 @@
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  surfinlw            !< longwave radiation falling to local surface including radiation from reflections
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  surfoutlw           !< total longwave radiation outgoing from nonvirtual surfaces surfaces after all reflection
-       
+
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  n_vg_green          !< vangenuchten parameters
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  alpha_vg_green      !< vangenuchten parameters
@@ -384,5 +391,5 @@
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  dz_wall_stag      !< wall grid spacing (edge-edge)
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ddz_wall_stag     !< 1/dz_wall_stag
-       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tt_wall_m         !< t_wall prognostic array 
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tt_wall_m         !< t_wall prognostic array
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zw                !< wall layer depths (m)
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  rho_c_window      !< volumetric heat capacity of the window material ( J m-3 K-1 ) (= 2.19E6)
@@ -391,5 +398,5 @@
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  dz_window_stag    !< window grid spacing (edge-edge)
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ddz_window_stag   !< 1/dz_window_stag
-       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tt_window_m       !< t_window prognostic array 
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tt_window_m       !< t_window prognostic array
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zw_window         !< window layer depths (m)
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  rho_c_green       !< volumetric heat capacity of the green material ( J m-3 K-1 ) (= 2.19E6)
@@ -399,5 +406,5 @@
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  dz_green_stag     !< green grid spacing (edge-edge)
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ddz_green_stag    !< 1/dz_green_stag
-       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tt_green_m        !< t_green prognostic array 
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tt_green_m        !< t_green prognostic array
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zw_green          !< green layer depths (m)
 
@@ -421,5 +428,5 @@
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  surfins_av       !< average of array of residua of sw radiation absorbed in surface after last reflection
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  surfinl_av       !< average of array of residua of lw radiation absorbed in surface after last reflection
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  surfhf_av        !< average of total radiation flux incoming to minus outgoing from local surface  
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  surfhf_av        !< average of total radiation flux incoming to minus outgoing from local surface
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  wghf_eb_av       !< average of wghf_eb
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  wghf_eb_window_av  !< average of wghf_eb window
@@ -437,5 +444,5 @@
 
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  pt_10cm_av       !< average of theta_10cm (K)
-       
+
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  t_wall_av      !< Average of t_wall
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  t_window_av    !< Average of t_window
@@ -455,12 +462,12 @@
     TYPE (surf_type), DIMENSION(0:3), TARGET ::  surf_usm_v  !< vertical urban surfaces (North, South, East, West)
 
-    INTEGER(iwp), PARAMETER ::  ind_veg_wall  = 0            !< index for vegetation / wall-surface fraction, used for access of albedo, emissivity, etc., for each surface type   
+    INTEGER(iwp), PARAMETER ::  ind_veg_wall  = 0            !< index for vegetation / wall-surface fraction, used for access of albedo, emissivity, etc., for each surface type
     INTEGER(iwp), PARAMETER ::  ind_pav_green = 1            !< index for pavement / green-wall surface fraction, used for access of albedo, emissivity, etc., for each surface type
     INTEGER(iwp), PARAMETER ::  ind_wat_win   = 2            !< index for water / window-surface fraction, used for access of albedo, emissivity, etc., for each surface type
 
-    INTEGER(iwp) ::  ns_h_on_file(0:2)                       !< total number of horizontal surfaces with the same facing, required for writing restart data 
-    INTEGER(iwp) ::  ns_v_on_file(0:3)                       !< total number of vertical surfaces with the same facing, required for writing restart data 
-
-    LOGICAL ::  vertical_surfaces_exist = .FALSE.   !< flag indicating that there are vertical urban/land surfaces 
+    INTEGER(iwp) ::  ns_h_on_file(0:2)                       !< total number of horizontal surfaces with the same facing, required for writing restart data
+    INTEGER(iwp) ::  ns_v_on_file(0:3)                       !< total number of vertical surfaces with the same facing, required for writing restart data
+
+    LOGICAL ::  vertical_surfaces_exist = .FALSE.   !< flag indicating that there are vertical urban/land surfaces
                                                     !< in the domain (required to activiate RTM)
 
@@ -468,4 +475,5 @@
     LOGICAL ::  surf_microphysics_morrison = .FALSE.   !< use 2-moment Morrison (add. prog. eq. for nc and qc)
     LOGICAL ::  surf_microphysics_seifert = .FALSE.    !< use 2-moment Seifert and Beheng scheme
+    LOGICAL ::  surf_microphysics_ice_extension = .FALSE. !< use 2-moment Seifert and Beheng scheme
 
 
@@ -473,5 +481,5 @@
 
     PRIVATE
-    
+
     INTERFACE init_bc
        MODULE PROCEDURE init_bc
@@ -481,5 +489,5 @@
        MODULE PROCEDURE init_single_surface_properties
     END INTERFACE init_single_surface_properties
-    
+
     INTERFACE init_surfaces
        MODULE PROCEDURE init_surfaces
@@ -522,5 +530,5 @@
            surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h, surf_usm_v, surf_type,      &
            vertical_surfaces_exist, surf_bulk_cloud_model, surf_microphysics_morrison,             &
-           surf_microphysics_seifert
+           surf_microphysics_seifert, surf_microphysics_ice_extension
 !
 !-- Public subroutines and functions
@@ -544,6 +552,6 @@
 ! Description:
 ! ------------
-!> Initialize data type for setting boundary conditions at horizontal and  
-!> vertical surfaces. 
+!> Initialize data type for setting boundary conditions at horizontal and
+!> vertical surfaces.
 !------------------------------------------------------------------------------!
     SUBROUTINE init_bc
@@ -559,10 +567,10 @@
        INTEGER(iwp), DIMENSION(0:1) ::  num_h_kji     !< number of horizontal surfaces at (j,i)-grid point
        INTEGER(iwp), DIMENSION(0:1) ::  start_index_h !< local start index of horizontal surface elements
-       
+
        INTEGER(iwp), DIMENSION(0:3) ::  num_v         !< number of vertical surfaces on subdomain
        INTEGER(iwp), DIMENSION(0:3) ::  num_v_kji     !< number of vertical surfaces at (j,i)-grid point
        INTEGER(iwp), DIMENSION(0:3) ::  start_index_v !< local start index of vertical surface elements
 !
-!--    Set offset indices, i.e. index difference between surface element and 
+!--    Set offset indices, i.e. index difference between surface element and
 !--    surface-bounded grid point.
 !--    Horizontal surfaces - no horizontal offsets
@@ -596,9 +604,9 @@
 !
 !--    Initialize data structure for horizontal surfaces, i.e. count the number
-!--    of surface elements, allocate and initialize the respective index arrays, 
-!--    and set the respective start and end indices at each (j,i)-location. 
-!--    The index space is defined also over the ghost points, so that e.g. 
-!--    boundary conditions for diagnostic quanitities can be set on ghost  
-!--    points so that no exchange is required any more. 
+!--    of surface elements, allocate and initialize the respective index arrays,
+!--    and set the respective start and end indices at each (j,i)-location.
+!--    The index space is defined also over the ghost points, so that e.g.
+!--    boundary conditions for diagnostic quanitities can be set on ghost
+!--    points so that no exchange is required any more.
        DO  l = 0, 1
 !
@@ -608,5 +616,5 @@
              DO  j = nysg, nyng
                 DO  k = nzb+1, nzt
-!         
+!
 !--                Check if current gridpoint belongs to the atmosphere
                    IF ( BTEST( wall_flags_total_0(k,j,i), 0 ) )  THEN
@@ -619,5 +627,5 @@
              ENDDO
           ENDDO
-!         
+!
 !--       Save the number of horizontal surface elements
           bc_h(l)%ns = num_h(l)
@@ -631,16 +639,16 @@
           bc_h(l)%start_index = 1
           bc_h(l)%end_index   = 0
-          
+
           num_h(l)         = 1
           start_index_h(l) = 1
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
-          
+
                 num_h_kji(l) = 0
                 DO  k = nzb+1, nzt
-!         
+!
 !--                Check if current gridpoint belongs to the atmosphere
                    IF ( BTEST( wall_flags_total_0(k,j,i), 0 ) )  THEN
-!         
+!
 !--                   Upward-facing
                       IF ( .NOT. BTEST( wall_flags_total_0(k+bc_h(l)%koff,     &
@@ -666,5 +674,5 @@
 !
 !--    Initialize data structure for vertical surfaces, i.e. count the number
-!--    of surface elements, allocate and initialize the respective index arrays, 
+!--    of surface elements, allocate and initialize the respective index arrays,
 !--    and set the respective start and end indices at each (j,i)-location.
        DO  l = 0, 3
@@ -675,5 +683,5 @@
              DO  j = nys, nyn
                 DO  k = nzb+1, nzt
-!         
+!
 !--                Check if current gridpoint belongs to the atmosphere
                    IF ( BTEST( wall_flags_total_0(k,j,i), 0 ) )  THEN
@@ -686,11 +694,11 @@
              ENDDO
           ENDDO
-!         
+!
 !--       Save the number of horizontal surface elements
           bc_v(l)%ns = num_v(l)
 !
 !--       ALLOCATE arrays for horizontal surfaces. In contrast to the
-!--       horizontal surfaces, the index space is not defined over the 
-!--       ghost points. 
+!--       horizontal surfaces, the index space is not defined over the
+!--       ghost points.
           ALLOCATE( bc_v(l)%i(1:bc_v(l)%ns) )
           ALLOCATE( bc_v(l)%j(1:bc_v(l)%ns) )
@@ -700,16 +708,16 @@
           bc_v(l)%start_index = 1
           bc_v(l)%end_index   = 0
-          
+
           num_v(l)         = 1
           start_index_v(l) = 1
           DO  i = nxl, nxr
              DO  j = nys, nyn
-          
+
                 num_v_kji(l) = 0
                 DO  k = nzb+1, nzt
-!         
+!
 !--                Check if current gridpoint belongs to the atmosphere
                    IF ( BTEST( wall_flags_total_0(k,j,i), 0 ) )  THEN
-!         
+!
 !--                   Upward-facing
                       IF ( .NOT. BTEST( wall_flags_total_0(k+bc_v(l)%koff,     &
@@ -741,5 +749,5 @@
 ! ------------
 !> Initialize horizontal and vertical surfaces. Counts the number of default-,
-!> natural and urban surfaces and allocates memory, respectively. 
+!> natural and urban surfaces and allocates memory, respectively.
 !------------------------------------------------------------------------------!
     SUBROUTINE init_surface_arrays
@@ -751,15 +759,15 @@
        IMPLICIT NONE
 
-       INTEGER(iwp)                 ::  i         !< running index x-direction 
+       INTEGER(iwp)                 ::  i         !< running index x-direction
        INTEGER(iwp)                 ::  j         !< running index y-direction
        INTEGER(iwp)                 ::  k         !< running index z-direction
        INTEGER(iwp)                 ::  l         !< index variable for surface facing
-       INTEGER(iwp)                 ::  num_lsm_h !< number of horizontally-aligned natural surfaces 
-       INTEGER(iwp)                 ::  num_usm_h !< number of horizontally-aligned urban surfaces 
-
-       INTEGER(iwp), DIMENSION(0:2) ::  num_def_h !< number of horizontally-aligned default surfaces 
-       INTEGER(iwp), DIMENSION(0:3) ::  num_def_v !< number of vertically-aligned default surfaces 
-       INTEGER(iwp), DIMENSION(0:3) ::  num_lsm_v !< number of vertically-aligned natural surfaces 
-       INTEGER(iwp), DIMENSION(0:3) ::  num_usm_v !< number of vertically-aligned urban surfaces 
+       INTEGER(iwp)                 ::  num_lsm_h !< number of horizontally-aligned natural surfaces
+       INTEGER(iwp)                 ::  num_usm_h !< number of horizontally-aligned urban surfaces
+
+       INTEGER(iwp), DIMENSION(0:2) ::  num_def_h !< number of horizontally-aligned default surfaces
+       INTEGER(iwp), DIMENSION(0:3) ::  num_def_v !< number of vertically-aligned default surfaces
+       INTEGER(iwp), DIMENSION(0:3) ::  num_lsm_v !< number of vertically-aligned natural surfaces
+       INTEGER(iwp), DIMENSION(0:3) ::  num_usm_v !< number of vertically-aligned urban surfaces
 
        INTEGER(iwp)              ::  num_surf_v_l !< number of vertically-aligned local urban/land surfaces
@@ -768,6 +776,6 @@
        LOGICAL ::  building                       !< flag indicating building grid point
        LOGICAL ::  terrain                        !< flag indicating natural terrain grid point
-       LOGICAL ::  unresolved_building            !< flag indicating a grid point where actually a building is 
-                                                  !< defined but not resolved by the vertical grid 
+       LOGICAL ::  unresolved_building            !< flag indicating a grid point where actually a building is
+                                                  !< defined but not resolved by the vertical grid
 
        num_def_h = 0
@@ -780,9 +788,9 @@
 !--    Surfaces are classified according to the input data read from static
 !--    input file. If no input file is present, all surfaces are classified
-!--    either as natural, urban, or default, depending on the setting of 
+!--    either as natural, urban, or default, depending on the setting of
 !--    land_surface and urban_surface. To control this, use the control
 !--    flag topo_no_distinct
 !
-!--    Count number of horizontal surfaces on local domain 
+!--    Count number of horizontal surfaces on local domain
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -798,5 +806,5 @@
 !
 !--                   Determine flags indicating a terrain surface, a building
-!--                   surface, 
+!--                   surface,
                       terrain  = BTEST( wall_flags_total_0(k-1,j,i), 5 )  .OR.       &
                                  topo_no_distinct
@@ -804,5 +812,5 @@
                                  topo_no_distinct
 !
-!--                   unresolved_building indicates a surface with equal height 
+!--                   unresolved_building indicates a surface with equal height
 !--                   as terrain but with a non-grid resolved building on top.
 !--                   These surfaces will be flagged as urban surfaces.
@@ -813,18 +821,18 @@
                       IF ( land_surface  .AND.  terrain  .AND.                 &
                            .NOT. unresolved_building )  THEN
-                         num_lsm_h    = num_lsm_h    + 1 
+                         num_lsm_h    = num_lsm_h    + 1
 !
 !--                   Urban surface tpye
                       ELSEIF ( urban_surface  .AND.  building )  THEN
-                         num_usm_h    = num_usm_h    + 1 
+                         num_usm_h    = num_usm_h    + 1
 !
 !--                   Default-surface type
                       ELSEIF ( .NOT. land_surface    .AND.                     &
                                .NOT. urban_surface )  THEN
-                               
+
                          num_def_h(0) = num_def_h(0) + 1
 !
 !--                   Unclassifified surface-grid point. Give error message.
-                      ELSE 
+                      ELSE
                          WRITE( message_string, * )                           &
                                           'Unclassified upward-facing ' //    &
@@ -840,9 +848,9 @@
                       num_def_h(2) = num_def_h(2) + 1
 !
-!--                Check for any other downward-facing surface. So far only for 
+!--                Check for any other downward-facing surface. So far only for
 !--                default surface type.
                    ELSEIF ( .NOT. BTEST( wall_flags_total_0(k+1,j,i), 0 ) )  THEN
                       num_def_h(1) = num_def_h(1) + 1
-                   ENDIF 
+                   ENDIF
 
                 ENDIF
@@ -851,5 +859,5 @@
        ENDDO
 !
-!--    Count number of vertical surfaces on local domain 
+!--    Count number of vertical surfaces on local domain
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -869,18 +877,18 @@
                       unresolved_building = BTEST( wall_flags_total_0(k,j-1,i), 5 )  &
                                      .AND.  BTEST( wall_flags_total_0(k,j-1,i), 6 )
-                                     
+
                       IF (  land_surface  .AND.  terrain  .AND.                &
                            .NOT. unresolved_building )  THEN
-                         num_lsm_v(0) = num_lsm_v(0) + 1 
+                         num_lsm_v(0) = num_lsm_v(0) + 1
                       ELSEIF ( urban_surface  .AND.  building )  THEN
-                         num_usm_v(0) = num_usm_v(0) + 1 
+                         num_usm_v(0) = num_usm_v(0) + 1
 !
 !--                   Default-surface type
                       ELSEIF ( .NOT. land_surface    .AND.                     &
                                .NOT. urban_surface )  THEN
-                         num_def_v(0) = num_def_v(0) + 1 
+                         num_def_v(0) = num_def_v(0) + 1
 !
 !--                   Unclassifified surface-grid point. Give error message.
-                      ELSE 
+                      ELSE
                          WRITE( message_string, * )                            &
                                           'Unclassified northward-facing ' //  &
